%% Zeit-Prozentkennwert-Verfahren.
% Prof.em., Dr.-Ing. S.Zacher, Stuttgart, 2021 www.zacher-automation.de
%% 1. Die Datei "32587.txt" als Numeric Matrix "data" einlesen
clear all;
data =readmatrix('32587.txt'); 
% Rechtsklick im Workspace, dann mit dem Befehl "Save" als 32587.mat speichern
%% 2. Messwerte in Matlab plotten
load('32587.mat') 
t = data(:,1);      % Spalte 1 (Zeit) aus Matrix "data" extrahieren
y = data(:,2);      % Spalte 2 (Stellwert) aus "data" extrahieren (blau)
x = data(:,3);      % Spalte 3 (Regelgröße) aus "data" extrahieren (rot)
s = tf('s');        % Laplace-Operator ("Control System Toolbox" nötig)

figure
plot(t,y,t,x, 'Linewidth',3)      % Sprung (blau) und Sprungantwort(rot)
grid on;                                            % Netzgitter
title('Original Messwerte einer Regelstrecke');     % Titel des Bildes 
xlabel('Zeit t [sec]');                             % Achsenbeschriftung
legend('Sprung y1','Sprungantwort x1','Location','northeast');
%% Koordinatenanfang verschieben, die Sprunganwort zoomen
% Werte aus "figure" ablesen
Xanf=input('Xanf=');% in MATLAB Command Window eintippen, Xanf=505
Xend=input('Xend='); % in MATLAB Command Window eintippen, Xend=1380
Yanf=input('Yanf='); % in MATLAB Command Window eintippen, Yanf=30
Yend=input('Yend='); % in MATLAB Command Window eintippen, Yend=580
t0=input('t0='); % in MATLAB Command Window eintippen, t0=5
t_ax=input('t_ax='); % gewünschte Fenstergröße, Abszisse, t_ax=1.5
x_ax=input('x_ax='); % gewünschte Fenstergröße, Ordinate, x_ax=900
tm=t-t0;             % Zeitachse verschieben
xm=x-Xanf;           % Ordinatenachse verschieben
figure
plot(tm,xm,'r','Linewidth',3)       % Messwerte (rote Kurve)
hold on                             % messwerte im Bild halten
G=s/s;                              % Fiktive Größe, um Plot zoomen
step(x_ax*G,t_ax);                  % Plot wird gezoomt
hold on
grid
%% Kps bestimmen, Prozentwerte x10, x50, x90 bestimmen
x_oo=Xend-Xanf;     % t=unendlich (oo). Abweichung x vom Arbeitpunkt Xanf
y0=Yend-Yanf;       % Abweichung y der Stellgröße y vom Arbeitspunkt Yanf
KpS=x_oo/y0;        % Proportionalbeiwert der Strecke 
x10=0.1*x_oo        % Regelgröße: 10% des Beharrungswertes  
x50=0.5*x_oo        % Regelgröße: 50% des Beharrungswertes
x90=0.9*x_oo        % Regelgröße: 90% des Beharrungswertes
%% Zeit-Prozentkennwert Algorithmus und Vergleich mit Messwerten
t10=input('t10=');  % aus der Sprungantwort ablesen und eintippen, t10=0.166
t50=input('t50=');  % aus der Sprungantwort ablesen und eintippen, t50=0.419
t90=input('t90=');  % aus der Sprungantwort ablesen und eintippen, t90=0.709
my=t10/t90          % Griechische "My" berechnen
n=input('n=');      % Ordnung n aus der Tabelle ablesen und eintippen, n=3      
alpha10=input('alpha10=');  % aus der Tabelle ablesen und eintippen, 0.907
alpha50=input('alpha50=');  % aus der Tabelle ablesen und eintippen, 0.374
alpha90=input('alpha90=');  % aus der Tabelle ablesen und eintippen, 0.188
T=(alpha10*t10+alpha50*t50+alpha90*t90)/3; % Zeitkonstante T berechnen
Gs=KpS/(1+s*T)^n;       % Übertragungsfunktion der PTn-Strecke
step(y0*Gs,t_ax,'b*')   % Sprungantwort der identififizeirten PTn-Strecke
% Vergleich der identifizierten Strecke mit Messwerten
legend('Messwerte',' *Identifizierte Strecke','Location','southeast');





